/*
 * $Id: GlobalRes.java,v 1.5 2004/06/23 19:49:35 nunnari Exp $
 *
 * Copyright (c) 2003-2004 Roberto Nunnari - roberto.nunnari@nunnisoft.ch
 * All rights reserved.
 *
 *  This file is part of NunniFSMGen.
 *
 *  NunniFSMGen is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  NunniFSMGen is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NunniFSMGen; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.nunnisoft.fsmgen.lang;

/**
 *
 * @author  Roberto Nunnari
 */
public final class GlobalRes extends java.util.ListResourceBundle {

    public static final String IS_NOT_VALID_OPTION = "IS_NOT_VALID_OPTION";
    public static final String IS_NOT_YET_SUPPORTED = "IS_NOT_YET_SUPPORTED";
    public static final String IS_NOT_VALID_LANGUAGE = "IS_NOT_VALID_LANGUAGE";
    public static final String GENERATING = "GENERATING";
    public static final String GEN_JAVA_SRC = "GEN_JAVA_SRC";
    public static final String GEN_CXX_SRC = "GEN_CXX_SRC";
    public static final String GEN_C_SRC = "GEN_C_SRC";
    public static final String ALREADY_EXISTS = "ALREADY_EXISTS";
    public static final String VERSION = "VERSION";
    public static final String USAGE = "USAGE";

    private static final String m_usage =
        "************************************ USAGE ************************************\n" +
        "java -jar NunniFSMGen.jar [options] configurationFile\n" +
        "  options:\n" +
        "    -?              : show usage\n" +
        "    -V              : show version\n" +
        "    -i              : show program info\n" +
        "    -v              : verbose\n" +
        "    -o {java|c|c++} : language generated (default: java)\n" +
        "    -p              : package (default: read from file else ^generated')\n" +
        "    -n              : basename (default: read from file else 'Context')\n" +
        "  configurationFile : file containing the FSM transition table";
    
    protected Object[][] getContents() {
        return contents;
    }

    private static final Object[][] contents = {
        { IS_NOT_VALID_OPTION, "is not a valid option" },
        { IS_NOT_YET_SUPPORTED, "is not yet supported" },
        { IS_NOT_VALID_LANGUAGE, "is not a supported language" },
        { GENERATING, "generating" },
        { GEN_JAVA_SRC, "generating java source!" },
        { GEN_CXX_SRC, "generating C++ source!" },
        { GEN_C_SRC, "generating C source!" },
        { ALREADY_EXISTS, "already exists.. alternate name for new file" },
        { VERSION, "Nunni FSM Generator - version" },
        { USAGE, m_usage },
    };
}
