/*
 * this file was generated by NunniFSMGen - do not edit!
 */


#include "DogFSM.h"
#include "Dog.h"

#include <stdlib.h>


#define m_maxFSMs 5


struct DogState {
  int (*noise)( struct DogFSM *fsm, void * o );
  int (*beer)( struct DogFSM *fsm, void * o );
};


struct DogFSM {
  int (*noise)( struct DogFSM *fsm, void * o );
  int (*beer)( struct DogFSM *fsm, void * o );

  void (*changeState)( struct DogFSM *fsm, struct DogState *nextState );
  struct DogState *m_state;
};


static int m_initialized = 0;
static struct DogState m_DogSleepState;
static struct DogState m_DogAwakeState;
static struct DogState m_DogSickState;


static struct DogFSM  * m_FSM[m_maxFSMs];
static int m_FSMSize = 0;


int DogSleepStatenoise( struct DogFSM *fsm,  void * o ) {
  int ret = sleepNoise( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_DogSickState );
  else
    fsm->changeState( fsm, &m_DogAwakeState );
  return ret;
}


int DogSleepStatebeer( struct DogFSM *fsm,  void * o ) {
  int ret = burp( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_DogSickState );
  return ret;
}


int DogAwakeStatenoise( struct DogFSM *fsm,  void * o ) {
  int ret = awakeNoise( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_DogSickState );
  return ret;
}


int DogAwakeStatebeer( struct DogFSM *fsm,  void * o ) {
  int ret = awakeBeer( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_DogSickState );
  else
    fsm->changeState( fsm, &m_DogSleepState );
  return ret;
}


int DogSickStatenoise( struct DogFSM *fsm,  void * o ) {
  return 0;
}


int DogSickStatebeer( struct DogFSM *fsm,  void * o ) {
  return 0;
}


int DogFSMnoise( struct DogFSM *fsm, void * o ) {
  return fsm->m_state->noise( fsm, o );
}


int DogFSMbeer( struct DogFSM *fsm, void * o ) {
  return fsm->m_state->beer( fsm, o );
}


void DogFSMChangeState( struct DogFSM *fsm, struct DogState *newState ) {
    fsm->m_state = newState;
}


struct DogFSM * DogFSMCreate() {
  if ( m_FSMSize >= m_maxFSMs )
    return 0;
  if ( !m_initialized ) {
    m_initialized = 1;
    m_DogSleepState.noise = DogSleepStatenoise;
    m_DogSleepState.beer = DogSleepStatebeer;
    m_DogAwakeState.noise = DogAwakeStatenoise;
    m_DogAwakeState.beer = DogAwakeStatebeer;
    m_DogSickState.noise = DogSickStatenoise;
    m_DogSickState.beer = DogSickStatebeer;
  }
  m_FSM[m_FSMSize] = malloc( sizeof(struct DogFSM) );
  m_FSM[m_FSMSize]->noise = DogFSMnoise;
  m_FSM[m_FSMSize]->beer = DogFSMbeer;
  m_FSM[m_FSMSize]->changeState = DogFSMChangeState;
  m_FSM[m_FSMSize]->m_state = &m_DogSleepState;
  return (m_FSM[m_FSMSize++]);
}


void DogFSMDelete( struct DogFSM *fsm ) {
  int i;
  int index = -1;

  if ( m_FSMSize == 0 || fsm == NULL )
    return;

  for ( i = 0; i < m_FSMSize; ++i ) {
    if ( m_FSM[i] == fsm ) {
      index = i;
      break;
    }
  }

  if ( index == -1 )
    return;

  --m_FSMSize;

  for ( i = index ; i < m_FSMSize; ++i ) {
    m_FSM[i] = m_FSM[i+1];
  }

  if ( m_FSMSize == index )
    m_FSM[m_FSMSize] = (struct DogFSM *)NULL;

  free( fsm );
}
