/*
 * $Id: HeaterFSM.c,v 1.2 2004/02/15 12:45:49 nunnari Exp $
 *
 * Copyright (c) 2004 Roberto Nunnari - roberto.nunnari@nunnisoft.ch
 * All rights reserved.
 *
 *  This file is part of NunniFSMGen examples suite.
 *
 *  NunniFSMGen is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  NunniFSMGen is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with NunniFSMGen; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * this file was generated by NunniFSMGen - do not edit!
 */


#include "HeaterFSM.h"
#include "Heater.h"


#define m_maxFSMs 5


struct HeaterState {
  int (*activate)( struct HeaterFSM *fsm, void *o );
  int (*deactivate)( struct HeaterFSM *fsm, void *o );
  int (*hotenough)( struct HeaterFSM *fsm, void *o );
  int (*maintenance)( struct HeaterFSM *fsm, void *o );
};


struct HeaterFSM {
  int (*activate)( struct HeaterFSM *fsm, void *o );
  int (*deactivate)( struct HeaterFSM *fsm, void *o );
  int (*hotenough)( struct HeaterFSM *fsm, void *o );
  int (*maintenance)( struct HeaterFSM *fsm, void *o );

  void (*changeState)( struct HeaterFSM *fsm, struct HeaterState *nextState );
  struct HeaterState *m_state;
};


static int m_initialized = 0;
static struct HeaterState m_HeaterSTANDBYState;
static struct HeaterState m_HeaterWARMINGUPState;
static struct HeaterState m_HeaterERRORState;
static struct HeaterState m_HeaterMAINTENANCEState;


static struct HeaterFSM  m_FSM[m_maxFSMs];
static int m_FSMSize = 0;


int HeaterSTANDBYStateactivate( struct HeaterFSM *fsm,  void *o ) {
  int ret = warmup( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_HeaterERRORState );
  else
    fsm->changeState( fsm, &m_HeaterWARMINGUPState );
  return ret;
}


int HeaterSTANDBYStatedeactivate( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterSTANDBYStatehotenough( struct HeaterFSM *fsm,  void *o ) {
  fsm->changeState( fsm, &m_HeaterERRORState );
  return -1;
}


int HeaterSTANDBYStatemaintenance( struct HeaterFSM *fsm,  void *o ) {
  int ret = maintain( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_HeaterERRORState );
  else
    fsm->changeState( fsm, &m_HeaterMAINTENANCEState );
  return ret;
}


int HeaterWARMINGUPStateactivate( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterWARMINGUPStatedeactivate( struct HeaterFSM *fsm,  void *o ) {
  int ret = heateroff( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_HeaterERRORState );
  else
    fsm->changeState( fsm, &m_HeaterSTANDBYState );
  return ret;
}


int HeaterWARMINGUPStatehotenough( struct HeaterFSM *fsm,  void *o ) {
  int ret = heateroff( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_HeaterERRORState );
  else
    fsm->changeState( fsm, &m_HeaterSTANDBYState );
  return ret;
}


int HeaterWARMINGUPStatemaintenance( struct HeaterFSM *fsm,  void *o ) {
  int ret = heateroff( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_HeaterERRORState );
  else
    fsm->changeState( fsm, &m_HeaterMAINTENANCEState );
  return ret;
}


int HeaterERRORStateactivate( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterERRORStatedeactivate( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterERRORStatehotenough( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterERRORStatemaintenance( struct HeaterFSM *fsm,  void *o ) {
  fsm->changeState( fsm, &m_HeaterMAINTENANCEState );
  return 0;
}


int HeaterMAINTENANCEStateactivate( struct HeaterFSM *fsm,  void *o ) {
  int ret = initialize( o );
  if ( ret < 0 )
    fsm->changeState( fsm, &m_HeaterERRORState );
  else
    fsm->changeState( fsm, &m_HeaterSTANDBYState );
  return ret;
}


int HeaterMAINTENANCEStatedeactivate( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterMAINTENANCEStatehotenough( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterMAINTENANCEStatemaintenance( struct HeaterFSM *fsm,  void *o ) {
  return 0;
}


int HeaterFSMactivate( struct HeaterFSM *fsm, void *o ) {
  return fsm->m_state->activate( fsm, o );
}


int HeaterFSMdeactivate( struct HeaterFSM *fsm, void *o ) {
  return fsm->m_state->deactivate( fsm, o );
}


int HeaterFSMhotenough( struct HeaterFSM *fsm, void *o ) {
  return fsm->m_state->hotenough( fsm, o );
}


int HeaterFSMmaintenance( struct HeaterFSM *fsm, void *o ) {
  return fsm->m_state->maintenance( fsm, o );
}


void HeaterFSMChangeState( struct HeaterFSM *fsm, struct HeaterState *newState ) {
    fsm->m_state = newState;
}


struct HeaterFSM * HeaterFSMCreate() {
  int i;
  struct HeaterFSM *aHeaterFSM = &(m_FSM[m_FSMSize]);
  if ( m_FSMSize >= m_maxFSMs )
    return 0;
  if ( !m_initialized ) {
    m_initialized = 1;
    m_HeaterSTANDBYState.activate = HeaterSTANDBYStateactivate;
    m_HeaterSTANDBYState.deactivate = HeaterSTANDBYStatedeactivate;
    m_HeaterSTANDBYState.hotenough = HeaterSTANDBYStatehotenough;
    m_HeaterSTANDBYState.maintenance = HeaterSTANDBYStatemaintenance;
    m_HeaterWARMINGUPState.activate = HeaterWARMINGUPStateactivate;
    m_HeaterWARMINGUPState.deactivate = HeaterWARMINGUPStatedeactivate;
    m_HeaterWARMINGUPState.hotenough = HeaterWARMINGUPStatehotenough;
    m_HeaterWARMINGUPState.maintenance = HeaterWARMINGUPStatemaintenance;
    m_HeaterERRORState.activate = HeaterERRORStateactivate;
    m_HeaterERRORState.deactivate = HeaterERRORStatedeactivate;
    m_HeaterERRORState.hotenough = HeaterERRORStatehotenough;
    m_HeaterERRORState.maintenance = HeaterERRORStatemaintenance;
    m_HeaterMAINTENANCEState.activate = HeaterMAINTENANCEStateactivate;
    m_HeaterMAINTENANCEState.deactivate = HeaterMAINTENANCEStatedeactivate;
    m_HeaterMAINTENANCEState.hotenough = HeaterMAINTENANCEStatehotenough;
    m_HeaterMAINTENANCEState.maintenance = HeaterMAINTENANCEStatemaintenance;
    for ( i = 0; i < m_maxFSMs; ++i ) {
      aHeaterFSM->activate = HeaterFSMactivate;
      aHeaterFSM->deactivate = HeaterFSMdeactivate;
      aHeaterFSM->hotenough = HeaterFSMhotenough;
      aHeaterFSM->maintenance = HeaterFSMmaintenance;
      aHeaterFSM->changeState = HeaterFSMChangeState;
      aHeaterFSM->m_state = &m_HeaterSTANDBYState;
    }
  }
  ++m_FSMSize;
  return aHeaterFSM;
}


void HeaterFSMDelete( struct HeaterFSM *fsm ) {
  fsm->m_state = &m_HeaterSTANDBYState;
}
